% Computes the morphological profile of the image im, until depth r

function mp = morphological_profile(im,r,printit)

im_op = zeros(size(im,1),size(im,2),r);
im_cl = zeros(size(im,1),size(im,2),r);

% Closing images
for m=1:size(im_op,3)
    se=strel('disk',m);
    im2=imclose(im,se);
    if printit, figure,imagesc(im2),axis off, title(['Closing, disk 3x3, scale ' num2str(m)]),end
    im_cl(:,:,m)=im2;
end

% Opening images
for m=1:size(im_op,3)
    se=strel('disk',m);
    im1=imopen(im,se);
    if printit, figure,imagesc(im1),axis off, title(['Opening, disk 3x3, scale ' num2str(m)]),end
    im_op(:,:,m)=im1;
end

% Store all filtered images in a profile
clear mp
mp(:,:,1:size(im_cl,3))=im_cl(:,:,size(im_cl,3):-1:1);
mp(:,:,size(im_cl,3)+1)=im;
mp(:,:,(size(im_cl,3)+2):(size(im_cl,3)+size(im_op,3)+1))=im_op;

