function WT = wavelet_decomposition(X,printit)

n = 4;                   % Decomposition Level
w = 'db1';               % Haar wavelet
WT = ndwt2(X,n,w);        % Multilevel 2-D wavelet decomposition.

% Extract the coefficients
cAA = cell(1,n);
cAD = cell(1,n);
cDA = cell(1,n);
cDD = cell(1,n);
for k = 1:n
    cAA{k} = indwt2(WT,'caa',k);   % Coefficients of approximations
    cAD{k} = indwt2(WT,'cad',k);   % Coefficients of horizontal details
    cDA{k} = indwt2(WT,'cda',k);   % Coefficients of vertical details
    cDD{k} = indwt2(WT,'cdd',k);   % Coefficients of diagonal details
end

if printit
    % Plot the images at different scales
%     figure('DefaultAxesXTick',[],'DefaultAxesYTick',[])
    for k = 1:n
        figure, imagesc(cAA{k}), axis off square, title(['cAA' int2str(k)])
        eval(['print -depsc figures/wavelets_cAA' num2str(k) '.eps'])
        figure, imagesc(abs(cAD{k})); axis off square, title(['cAD' int2str(k)])
        eval(['print -depsc figures/wavelets_cAD' num2str(k) '.eps'])
        figure, imagesc(abs(cDA{k}));     axis off square, title(['cDA' int2str(k)])
        eval(['print -depsc figures/wavelets_cDA' num2str(k) '.eps'])
        figure, imagesc(abs(cDD{k})); axis off square, title(['cDD' int2str(k)])
        eval(['print -depsc figures/wavelets_cDD' num2str(k) '.eps'])
    end
    %     colormap(hot)
    %     title(['Haar wavelet decomposition, 4 levels'])
end

